;
; channel15.asm - channel 15 command execution
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
OP_XIT_do_command_channel .proc

		#xit_init

		#ldatax buffer_currentp_exp
		lda buffer_address_low_exp,x
		bne oknoy
		rts
rr		jmp LWOP_reporterror_32_xit;-=> buffer overflow

oknoy		cmp #255
		bcs rr			;buffer overflow
		pha
		#lda0
		sta buffer_address_low_exp,x
		sta pom1
		.if SUPERCPU=1
		inc a
		sta pom3
		.fi
		lda buffer_start,x
		sta pom2
		#ply_a
		dey
		#lda_zp_y pom1
		eor #13			;remove trailing CR
		beq *+3
		iny

                .if SUPERCPU=1
                phx
                .fi
		#lda0			;trailing zero
		.byte SKIP2

thnue		#lda_zp_y pom1		;copy from buffer to path
		#sta_l_y_x path_exp
		dey
		cpy #255
		bne thnue
                .if SUPERCPU=1
                plx
                .fi

OP_XIT_execute_15command_open .proc

		lda buffer_drive_exp,x
		sta current_drive_exp

		#xit_init

		jsr check_drive		;check drive is alive

		lda path_exp
		ldx #commandslo-commands
htnuo		cmp commands-1,x
		bne njooocmd
		lda commandshi-1,x
		pha
		lda commandslo-1,x
		pha
		lda path_exp+1
		rts

njooocmd	dex
		bne htnuo

		#jmps channel15_cont
;-------------------------------
;I
;
cmd_i		.proc
		jmp OP_XIT_init_filesystem_from_disk
		.pend
;-------------------------------
;C
;
cmd_c		.proc

		cmp #128+"P"
		bne cmd_cp
		jsr XIT_init_drive	;cP
		lda path_exp+2
in		jsr OP_check_partition_selection
		jsr LWOP_reporterror_77_xit;Invalid? -=> error
		#ldatax current_drive_exp
                tya
		sta drive_workpartition_exp,x
		adc #1
		tax
		ldy #0
		jmp LWOP_reporterror_02_xit
		.pend
;-------------------------------
;CP change partition
;
cmd_cp		.proc
		cmp #"P"
		bne cmd_cd
		jsr OP_short_path
		jsr OP_short_path
		ldx #255
gc		inx
		lda path_exp,x
		bne gc
		sta path_exp+1,x	;hack ;)
		lda #":"
		sta path_exp,x

		jsr XIT_init_drive
		jsr OP_get_partnum
		lda path_partition_exp
		jmp cmd_c.in
		.pend
;-------------------------------
;CD change dir
;
;CD:/	- go to root
;CD:<-	- go to parent
;CD:DIR	- go into dir
;
cmd_cd		.proc
		jsr OP_short_path	;eat "C"
		cmp #"D"		;CD hack ;)
		bne ide64
		jsr OP_short_path	;eat "D"
		cmp #95
		bne rp
		lda path_exp+1
		bne rp			;eol?

pphack		sta path_exp+2
		lda #"."
		sta path_exp
		sta path_exp+1
		gne cmd_cd2.in

rp		jsr OP_delimiter_in_path
		php
		jsr OP_get_partnum	;eat number
                plp
                bcc nne
		lda path_exp
                cmp #":"
                bne cmd_cd2.in
		lda path_exp+1
                cmp #95
                bne cmd_cd2.in
                jsr OP_short_path
                beq xj

nne		lda path_exp
		cmp #95
		bne bs
xj		jsr OP_short_path	;eat "<-"
		beq pphack		;CD<-
                #lda0			;error

bs	     	eor #"/"		;CD/
		cmp #1
                jsr LWOP_reporterror_30_xit;-=> error
                jsr OP_short_path	;eat "/"
                #jmps cmd_cd2.in

ide64		jsr OP_XIT_partnum_delimiter;-=> error
		#jmps cmd_cd2.in

cmd_cd2		.proc
		jsr OP_short_path
		jsr OP_get_partnum
		lda path_exp
		bne in
		sta path_exp+1
		lda #"/"		;root dir hack
		sta path_exp
in		jsr XIT_init_drive	;-=> error
		lda setup_atribut2_exp
                bmi du
                lda path_exp
                cmp #":"
                bne du
                jsr OP_short_path
du		lda #RESOLV_CD_MODE
		jsr OP_XIT_resolv_path	;-=> path
                jsr LWOP_reporterror_39_xit;-=> error

		#ldatax partition_currentp_exp

		ldy #0
bnmf		lda next_sector,y
		sta partition_workdir_exp,x
		inx
		iny
		cpy #4
		bne bnmf
		geq LWOP_reporterror_ok
		.pend
;-------------------------------
;S remove file
;
cmd_s		.proc
		jsr OP_short_path
                cmp #"-"
                bne nj
                lda #"S"
                #jmps channel15_cont
nj
		jsr XIT_init_drive	;-=> error
		lda #RESOLV_S_MODE
		jsr OP_XIT_resolv_path_part	;-=> path
                ldx #0
                .if SUPERCPU=1
                txy
                .else
                ldy #0
                .fi
                bcs LWOP_reporterror_01_xit;file not found
                
                jsr rewrite_file

		ldx #1
		ldy #0
		jmp LWOP_reporterror_01_xit

rewrite_file    .proc			;entry point for "@:"
		jsr XIT_filenamewp

		lda direntry_f_attrib_exp
		and #FATTR_DELETE | FTYPE_MASK
		eor #FATTR_DELETE | FTYPE_NORMAL
		bne LWOP_reporterror_26_xit; other type not done yet

                ldx #MAX_BUFFERS-1
leu             lda buffer_logical_exp,x
                beq nopen		;buffer valid?
                lda buffer_drive_exp,x
                cmp current_drive_exp
                bne nopen		;on this drive?
                lda buffer_type_exp,x
                cmp #BUFFERMODE_FILE
                bne nopen               ;used for file?

		lda #>b_cfs_file_misc_exp
		jsr buffer_subpart_cp2

                #phx_a

		ldy #<(b_cfs_file_treeroot_exp+3);check treeroot
		ldx #3
uiy2		#lda_zp_y current_path
		eor direntry_f_pointer_exp,x
                cpx #1
                bcs *+4
                and #$4f
                and #$ff
                bne nun
		dey
		dex
		bne uiy2
                sec                
                gcs LWOP_reporterror_26_xit;opened files can't be deleted!

nun             #plx_a
nopen		dex
		bpl leu

		#cnext next_sector , ram_exp_buffer0_exp

		jsr XIT_kill_entry	;remove directory entry

		lda direntry_f_attrib_exp
		bpl nono		;not closed file, so no freeing

		jsr eraseprepare

		lda #3
		sta scratch_sp_exp
rec_free
		ldy #3
		#ldatax scratch_sp_exp
		cmp #255
		bne ls
		jsr XIT_find_free_flush
nono		rts			;-=> exit

ls		lda ram_exp_buffer0_exp,x
		sta next_sector,y
		dex
		dey
		bpl ls
		#stx_l_a scratch_sp_exp

		lda #ram_exp_tree
		jsr XIT_read_a_sector

		lda #255
		sta scratch_p_exp
		gne in			;free tree sector too

slp		.if SUPERCPU=1
		sta scratch_p_exp
		.else
		lda scratch_p_exp
                .fi
		asl
		asl
		sta pom1
		lda #ram_exp_tree/2
		rol
		sta pom2
		.if SUPERCPU=1
		lda #1
		sta pom3
		.fi

		ldy #3
lw		#lda_zp_y pom1
		sta next_sector,y
		dey
		bpl lw
                jsr next_sector0
		beq null

in		jsr XIT_free_this_sector

null		.if SUPERCPU=1
		lda scratch_p_exp
                inc a
		.else
                inc scratch_p_exp
                .fi
		bpl slp

		.if SUPERCPU=1
		ldy #1
		sty current_path+2
                dey
		.else
		ldy #0
                .fi
		sty current_path
		lda #ram_exp_tree
		sta current_path+1

		lda #8
		sta pom1

ns		ldx #3
mi		#lda_zp_y current_path
		asl
		asl
		asl
		rol next_sector,x
		asl
		rol next_sector,x
		tya
		clc
		adc #4
		tay
		and #15
		bne mi
		dex
		bpl mi
		bcc *+4
		inc current_path+1

		jsr next_sector0
		beq sm

		#phy_a
                ldy #3
                tya
                sec
		adc scratch_sp_exp
		sta scratch_sp_exp
		tax
mr		lda next_sector,y
		sta ram_exp_buffer0_exp,x
		dex
		dey
		bpl mr
		#ply_a

sm		dec pom1
		bne ns
		geq rec_free
		.pend

XIT_kill_entry	.proc
		jsr XIT_posentry

		ldy #$18		;filetype exp
		#lda_zp_y pom1
		and #<~(FTYPE_MASK | FATTR_CLOSED)
		#sta_zp_y pom1

		lda #ram_exp_dir
		jmp XIT_write_a_sector	;first kill entry, than free space
                .pend
;-------------------------------
;B block commands
;
;B=R and B=W and B=P and B=T
;
cmd_b		.proc
		lda path_exp+1
		cmp #"="
		bne cmdnotimp
		lda path_exp+2
		cmp #"R"
		bne nread
		jsr blockc
		pha
		ldx #3
vt		lda next_sector,x
		bne noident
		dex
		bpl vt
		jsr OP_get_current_drive_type
		asl
		lda #ident_d
		bcc *+4
		lda #atapi_ident_d
		jsr ata_data_command
		jsr LWOP_reporterror_read_xit;-=> error
		pla
		jsr OP_read512_here
		jsr ata_pi_nomore_data
		jsr LWOP_reporterror_read_xit
		jmp LWOP_reporterror_ok

noident		jsr XIT_init_drive2
		pla
		jsr XIT_read_a_sector2
		jmp LWOP_reporterror_ok

nread		cmp #"W"
		bne nwrite
		jsr blockc
		pha
		lda direct_write_exp
		sec
		beq LWOP_reporterror_26_xit
		jsr XIT_init_drive2
		pla
		jsr XIT_write_a_sector2
		jmp LWOP_reporterror_ok

nwrite		cmp #"P"
		bne npos
		jsr chnl
		lda path_exp+4
		sec
		sbc #1
		sta buffer_address_low_exp,x
		php
		lda buffer_address_max_hi_exp,x
		clc
		sbc buffer_start,x
		plp
		and path_exp+5
		sbc #0
		clc
		adc buffer_start,x
		sta buffer_address_hi_exp,x
		jmp LWOP_reporterror_ok

npos		cmp #"T"
		bne cmdnotimp
                jsr blockc
                pha
		jsr XIT_init_drive2 
                lda #ATAPI_READ_TOC
                jsr OP_atapi_packet
		#ldatax path_exp+4
                and #$c0
                #pw 9
                txa
                and #2
                #pw 2
		lda path_exp+5
                #pw 6
                #pc 7,>$800
                jsr OP_atapi_datain_command
                jsr LWOP_reporterror_read_xit;-=> error
                pla
		jsr OP_read512_here
		jsr OP_read512
		jsr OP_read512
		jsr OP_read512
		jsr ata_pi_nomore_data
		jsr LWOP_reporterror_read_xit;-=> error
                jmp LWOP_reporterror_ok

err2		sec
		gcs LWOP_reporterror_70_xit


chnl		lda path_exp+3
		jsr search_channel_A
		bne err2
		lda buffer_type_exp,x
		cmp #BUFFERMODE_DIRECT
		bne err2
		rts

blockc		jsr chnl
		#cnext path_exp+4 , next_sector
		jsr OP_init_buffer_pointers
		lda buffer_start,x
		rts
		.pend
                
cmdnotimp	.proc
		sec
		gcs LWOP_reporterror_31_xit;Unknown command
		.pend

;-------------------------------
;P position
;
cmd_p		.proc
		lda path_exp+1
		jsr search_channel_A
		bne err2

		lda buffer_type_exp,x       ;-=> seeking only for CFS and ISO!
		cmp #BUFFERMODE_FILE
		beq xex
		cmp #BUFFERMODE_ISOFILE
		bne err2
xex
		lda buffer_info_exp,x
		ldy #stateless-statenow
ver		cmp statenow-1,y
		beq vy
		dey
		bne ver
err2		sec
		gcs LWOP_reporterror_70_xit

vy		lda #INFO_IGNORE	;be safe
		sta buffer_info_exp,x

		lda statewhat-1,y
		bpl vdrs		;buffer is not dirty

		#phy_a
		jsr update_filelen
		jsr XIT_flush_buf
		#ldatax buffer_currentp_exp
		#ply_a
vdrs
		lda buffer_filesize1_exp,x
		cmp path_exp+2
		lda buffer_filesize2_exp,x
		sbc path_exp+3
		lda buffer_filesize3_exp,x
		sbc path_exp+4
		lda buffer_filesize4_exp,x
		sbc path_exp+5

		lda stateless-1,y
		bcs less
		lda stateend-1,y	;reached eof
less		pha

		lda buffer_address_max_hi_exp,x
                clc
                sbc buffer_start,x
                pha
                eor #$ff
		and path_exp+3
		sta buffer_filepos2_exp,x
		lda path_exp+4
		sta buffer_filepos3_exp,x
		lda path_exp+5
		sta buffer_filepos4_exp,x

		#lda0
		sta buffer_address_end_hi_exp,x
		sta buffer_address_end_low_exp,x

		pla
		and path_exp+3
                sta path_exp+3
		ora path_exp+2
		beq more
                
		lda buffer_type_exp,x
		cmp #BUFFERMODE_ISOFILE
		bne cfs             

		lda buffer_filepos2_exp,x
                sta next_sector+3
		lda buffer_filepos3_exp,x
                sta next_sector+2
		lda buffer_filepos4_exp,x

		ldy #3      
ry              lsr 
                ror next_sector+2
                ror next_sector+3
                dey
                bne ry
                tay
                lda next_sector+3
                clc
                adc buffer_isofile_start1,x
                sta next_sector+3
                lda next_sector+2
                adc buffer_isofile_start2,x
                sta next_sector+2
                tya
                adc buffer_isofile_start3,x
                sta next_sector+1
		#lda0
                adc buffer_isofile_start4,x
                sta next_sector
                
		lda buffer_start,x
                jsr XIT_read_a_sector
                
                #jmps dddd
cfs
		lda statewhat-1,y
		pha
		jsr XIT_init_drive	;-=> error
		pla
		beq rrd
		jsr XIT_save_tree	;-=> error
		#jmps tr

rrd		jsr XIT_load_tree	;-=> error

tr		jsr XIT_read_in_buffer	;-=> error

dddd		#ldatax buffer_currentp_exp
                lda buffer_address_max_hi_exp,x
		sta buffer_address_end_hi_exp,x
		#lda0
		sta buffer_address_end_low_exp,x

		lda buffer_filesize1_exp,x
		sec
		sbc #1
		sta pom1
		lda buffer_filesize2_exp,x
		sbc buffer_filepos2_exp,x
		sta pom2
		lda buffer_filesize3_exp,x
		sbc buffer_filepos3_exp,x
		bne more
		lda buffer_filesize4_exp,x
		sbc buffer_filepos4_exp,x
		bcc more
		bne more

		lda buffer_address_max_hi_exp,x
		sec
		sbc buffer_start,x
		clc
		sbc pom2
		bcc more

		lda buffer_start,x
		ora pom2
		sta buffer_address_end_hi_exp,x
		lda pom1
		sta buffer_address_end_low_exp,x
more

		lda path_exp+2
		sec
		sbc #1
		sta buffer_address_low_exp,x
		lda path_exp+3
		sbc #0
		clc
		adc buffer_start,x
		cmp buffer_address_end_hi_exp,x
		bne *+4
		ora #$80
		sta buffer_address_hi_exp,x

		pla
		sta buffer_info_exp,x
		jmp LWOP_reporterror_ok

		.if EXPERIMENTAL=1
statenow	.byte INFO_BLK_READ ,INFO_BLK_R_EOF,INFO_BLK_WRITE,INFO_BLK_WRITE_DIRTY,INFO_BLK_RW    ,INFO_BLK_RW_EOF,INFO_BLK_RW_DIRTY,INFO_BLK_RW_EOF_DIRTY
stateless	.byte INFO_BLK_READ ,INFO_BLK_READ ,INFO_BLK_WRITE,INFO_BLK_WRITE      ,INFO_BLK_RW    ,INFO_BLK_RW    ,INFO_BLK_RW      ,INFO_BLK_RW
stateend	.byte INFO_BLK_R_EOF,INFO_BLK_R_EOF,INFO_BLK_WRITE,INFO_BLK_WRITE      ,INFO_BLK_RW_EOF,INFO_BLK_RW_EOF,INFO_BLK_RW_EOF  ,INFO_BLK_RW_EOF
statewhat	.byte 0             ,0             ,1             ,128                 ,1              ,1              ,128              ,128
		.else
statenow	.byte INFO_BLK_READ ,INFO_BLK_R_EOF
stateless	.byte INFO_BLK_READ ,INFO_BLK_READ 
stateend	.byte INFO_BLK_R_EOF,INFO_BLK_R_EOF
statewhat	.byte 0             ,0
                .fi
		.pend
;-------------------------------
;M make dir
;
;"MD:NEW"
;
cmd_m		.proc
		cmp #"-"
                bne nj
                lda #"M"
                #jmps channel15_cont

nj              jsr OP_short_path
		cmp #"D"		;MD hack ;)
		bne ide64
		jsr OP_short_path
ide64
		jsr XIT_init_drive	;-=> error

		lda #RESOLV_MD_MODE
		jsr OP_XIT_resolv_path_part;-=> error
		bcs jo
		sec
		gcs LWOP_reporterror_63_xit;-=> file exists
jo
		#lda0
		sta path_searchtype_exp
		lda #ram_exp_bitmap
                ldx #"/"
		jsr XIT_prealloc_dir_sector;-=> error

		jsr find_free_sector	;allocate dir sector

		#lda0
		tax
nw		sta ram_exp_buffer0_exp,x
		sta ram_exp_buffer0_exp+$100,x
		inx
		bne nw

		tay
ii2		#lda_l_y path_exp	;fill in filename
		beq vt
		iny
		.byte SKIP2
vt		lda #32
		sta ram_exp_buffer0_exp,x
		inx
		cpx #16
		bne ii2

		ldx #4
ns		lda cdir-1,x
		sta ram_exp_buffer0_exp-1+$18,x;type & attrib
		lda next_sector-1,x
		sta ram_exp_buffer0_exp-1+$10,x;pointer
                sta created_new_dir_sector_exp-1,x;for finalize_direntry
		lda resolv_this_dir_exp-1,x
		sta ram_exp_buffer0_exp-1+$14,x;parent
		dex
		bne ns
                and #%01001111
                sta ram_exp_buffer0_exp+$14;pointer
                lda next_sector
                and #%01001111
		sta ram_exp_buffer0_exp+$10;pointer
                
                stx pom1
                .if SUPERCPU=1
                inx
                stx pom3
                .fi
                lda #ram_exp_buffer0
                sta pom2
                ldy #$1c
                jsr LWOP_timestamp	;update timestamp

		lda #ram_exp_buffer0	;write out new dir sector
		jsr XIT_write_a_sector	;-=> error

		jsr XIT_find_free_flush	;-=> error

		ldx #2
sw		lda cdir+1,x
		sta path_searchtype_exp,x
		#lda0
		sta szam,x
		dex
		bpl sw
		sta szam+3

		lda #FTYPE_DIR | FATTR_EXEC | FATTR_READ | FATTR_WRITE | FATTR_DELETE | FATTR_CLOSED
		jsr XIT_finalize_direntry

		jmp LWOP_reporterror_ok

cdir		.byte FTYPE_DIR | FATTR_EXEC | FATTR_READ | FATTR_WRITE | FATTR_DELETE,"D","I","R"
		.pend
;-------------------------------
;R rename
;
;"R-H:NEW" rename header
;"R-P:NEW=OLD" rename partition
;
cmd_r		.proc
		jsr OP_short_path
                cmp #"D"
                beq cmd_rd

		jsr XIT_init_drive	;-=> error

		lda #RESOLV_R_MODE
		jsr OP_XIT_resolv_path_part;-=> error
		bcs jo
		sec
		lda resolv_anything_exp
		beq LWOP_reporterror_34_xit;-=> no filename
		gne LWOP_reporterror_63_xit;-=> file exists
jo

                lda path_exp
                ldy #0
                geq nkq
joqj    	jsr OP_short_path
nkq		jsr is_special_s
                bne kjq
                eor #"="
                beq xp
mw2             sec
                gcs LWOP_reporterror_33_xit

kjq     	cpy #16
		bcs joqj
                pha
                iny
                gne joqj

xp		cpy #16
		bcs dp
                #lda0
                pha
                iny
                bcc xp

dp		jsr OP_short_path

		lda path_searchtype_exp
                eor #"*"
		ora path_searchtype_exp+1
                cmp #1
                bcc kih

                ldx #0
                ldy #3
nn3             lda path_searchtype_exp,x
		beq tj
		cmp #32
		beq mw2
                cmp #"<"		;no < in type!
                beq mw2
                cmp #"/"		;no / in type!
                beq mw2
		jsr is_special_s
		beq mw2
                inx
tj              pha
                dey
                bne nn3
                sec

kih             php

	        ldx #3
p               lda resolv_this_dir_exp,x
                pha
                dex
                bpl p
                
                lda #RESOLV_R2_MODE
                jsr OP_XIT_resolv_path	;-=> error

                ldx #0
p2              pla
		cmp resolv_this_dir_exp,x
                sec
                bne LWOP_reporterror_39_xit;different directory!
                inx
                cpx #4
                bcc p2

		jsr XIT_filenamewp

		jsr XIT_posentry
                
                plp
                #sev set_v
                bcc kih2

		ldy #$1B		;filetype exp
sq              pla
		#cmp_zp_y pom1
                beq kx
		#sta_zp_y pom1
                clv
kx              dey
                cpy #$19
                bcs sq
                bvs kih2
                
                ldx #4
xjj             ldy #$19
                #lda_zp_y pom1
                cmp invl1,x
                bne xj
                iny
                #lda_zp_y pom1
                cmp invl2,x
                bne xj
                iny
                #lda_zp_y pom1
                cmp invl3,x
                beq LWOP_reporterror_64_xit
xj		dex
		bpl xjj
                clv
kih2
		ldy #$18
                #lda_zp_y pom1
                and #FTYPE_MASK | FATTR_CLOSED
                cmp #FTYPE_DIR
                beq LWOP_reporterror_26_xit;do not rename dirlabel
                and #FTYPE_MASK
                cmp #FTYPE_NORMAL
                beq thd
                bvc LWOP_reporterror_64_xit;rename of a reserved type! (eg. dir to prg)
thd
		ldy #$10
sq2             pla
		dey
		#sta_zp_y pom1
                bne sq2

		lda #ram_exp_dir
		jsr XIT_write_a_sector	;write out new dir sector

set_v           jmp LWOP_reporterror_ok

invl1		.text "DRCDL"
invl2		.text "EEBIN"
invl3		.text "LLMRK"

		.pend
;-------------------------------
;RD rmdir
;
cmd_rd		.proc
		jsr XIT_init_drive	;-=> error

		lda #RESOLV_RD_MODE
		jsr OP_XIT_resolv_path_part;-=> error
re              ldx #0
re2             ldy #0
		bcs LWOP_reporterror_01_xit;-=> file not found

		jsr XIT_filenamewp

		lda direntry_f_attrib_exp
		and #FATTR_DELETE | FTYPE_MASK | FATTR_CLOSED
		eor #FATTR_DELETE | FTYPE_DIR | FATTR_CLOSED
kqk     	bne LWOP_reporterror_26_xit;write protected
                
                sec
                ldy #3
                tya
		ora partition_currentp_exp
                tax
lk              lda next_sector,y
                pha
		eor partition_workdir_exp,x
                beq *+3
                clc
                dex
                dey
                bpl lk
                bcs kqk			;cannot remove the working directory

;		clc
		jsr XIT_test
                
                jsr XIT_kill_entry	;remove directory entry

		jsr eraseprepare

		ldx #0
ll		pla
                sta next_sector,x
                inx
		cpx #4
		bne ll

                sec
                jsr XIT_test
		jsr XIT_find_free_flush
                ldx #1
                sec
                gcs re2
                
XIT_test       	#lda0
		sta current_path
                .byte SKIP1
lo		plp
                php
                bcc sk

		ldx #3
le              lda next_sector,x
                pha
                dex
                bpl le

                jsr XIT_free_this_sector

		ldx #0
le2             pla
                sta next_sector,x
                inx
                cpx #4
                bne le2

sk
		jsr XIT_upload_next_sector;-=> error
		ldy #1			;1 sector
		jsr OP_read
		jsr LWOP_reporterror_read_xit;-=> error
                
                ldy #15
nj2             ldx #11
nj              bit data_g
                dex
                bne nj
                tya
                lsr
                lsr
                tax
                lda low_reg
                asl
		asl
		asl
		rol next_sector,x
		asl
		rol next_sector,x
		bit data_g
		bit data_g
                lda low_reg
                and #FATTR_CLOSED | FTYPE_MASK
                beq xjx
                cmp #FTYPE_DIR
                beq xjx
                sec
                rol current_path
xjx             bit data_g
                bit data_g
                bit data_g
                dey
                bpl nj2

		jsr ata_pi_nomore_data
		jsr LWOP_reporterror_read_xit;-=> error
                plp
                php
                bcs sk2

                lda current_path
                sec
                bne re
sk2
		jsr next_sector0
                bne lo
                plp
                rts
		.pend
;-------------------------------
;Free the next_sector in bam
;
XIT_free_this_sector .proc
                jsr chs2lba

		lda szam+0
		sec
		sbc find_free_start_exp+0
		pha
		#stz_a szam+0
		lda szam+1
		sbc find_free_start_exp+1
		pha
		and #$f0
		sta szam+1
		lda szam+2
		sbc find_free_start_exp+2
		sta szam+2
		lda szam+3
		sbc find_free_start_exp+3
		sta szam+3

		ldx #3
ce		lda szam,x
		cmp scratch_now_exp,x
		bne vw
		dex
		bne ce
		geq ncw

vw		
		ldx #0
		lda find_free_bam_exp
		lsr
		ldy #3
li		lda szam,x
		sta scratch_now_exp,x
		adc find_free_start_exp,x
		pha
		inx
		dey
		bpl li

		jsr XIT_find_free_flush

		ldx #3
li2             pla
                sta szam,x
                sta find_free_now_exp,x
                dex
                bpl li2

                jsr isbamlocked
                lda buffer_start,x
                ora #>b_cfs_file_bitmap_exp	;modify bam directly in file's bam
		bcs *+4
                lda #ram_exp_bitmap		;modify bam in own buffer
                sta find_free_buf_exp+1
                bcs noread

		jsr readinbam.in

noread          lda #1
                sta find_free_dirty_exp

ncw		pla
		and #$0f
		sta pom2
		pla
                .if SUPERCPU=1
		tay
		and #7
		tax
		tya
                .else
                ldx #7
                sbx #0
                .fi

		lsr pom2
		ror
		lsr pom2
		ror
		lsr pom2
		ror
		sta pom1
		lda pom2
                ora find_free_buf_exp+1
		sta pom2
		.if SUPERCPU=1
		lda #1
		sta pom3
		lda [pom1]
		ora bm,x
		sta [pom1]
		.else
		ldy #0
		lda (pom1),y
		ora bm,x
		sta (pom1),y
		.fi
                rts
                
bm		.byte %10000000
		.byte %01000000
		.byte %00100000
		.byte %00010000
		.byte %00001000
		.byte %00000100
		.byte %00000010
		.byte %00000001
                .pend
;-------------------------------
;Read in directory sector and position on file (scratch, rename)
;
XIT_posentry 	.proc
		#cnext resolv_this_sector_exp , next_sector

		lda resolv_entry_offs_exp
		lsr
		ror
		ror
		ror
		sta pom1
		lda #ram_exp_dir/2
		rol
		sta pom2
		.if SUPERCPU=1
		lda #1
		sta pom3
		.fi
		rts
                .pend
;-------------------------------
;Check nonexistent filename and if partition is writeable
;
XIT_filenamewp	.proc
		lda resolv_anything_exp
		sec
		beq LWOP_reporterror_34_xit;-=> no filename

		#ldatax partition_currentp_exp
		lda partition_start_exp,x
		and #PATTR_WRITEABLE
	      	beq LWOP_reporterror_26_xit;write protected
                
		lda resolv_dirattrib_exp
                and #FATTR_WRITE
                beq LWOP_reporterror_26_xit;write protected directory
                rts
		.pend
;-------------------------------
;Common prepare for S and RD
;
eraseprepare	.proc
		#ldatax partition_currentp_exp
		lda partition_root_dir_exp,x
		asl
		lda #FIND_FREE_DATA
                sta find_free_mode_exp	;important!
		#lda0
                sta find_free_dirty_exp
		tay
		rol
		sta find_free_bam_exp
                txa
                adc #4
                tax

		jsr partitionstartinlba

		ldy #0
		ldx #3
ll		lda szam,x
		sta find_free_start_exp,x
		lda #255
		sta scratch_now_exp,x
                iny
		dex
		bpl ll
		rts
                .pend
;-------------------------------
search_channel_A .proc
		ora #$60
		sta pom2
		#ldatax buffer_currentp_exp;channel 15's buffer
		lda buffer_logical_exp,x
		ldx #MAX_OPEN_FILES
lp		dex
		bmi exit
		cmp open_files_logical_exp,x
		bne lp
		lda open_files_device_exp,x;now we have the drivenumber we are on
		sta pom1
		ldx #MAX_OPEN_FILES
lp2		dex
		bmi exit
		lda pom1
		cmp open_files_device_exp,x;on this drive?
		bne lp2
		lda pom2
		cmp open_files_secondary_exp,x;channel correct?
		bne lp2
		lda open_files_logical_exp,x;file open?
		beq lp2
		gne search_buffer_A
exit		rts
		.pend

;V validate
;I initialize
;/ path (1581)
;M memory
;  MD mkdir
;  M-R memory read
;  M-W memory write
;  M-E memory execute
;B block
;  B-A block allocate
;  B-F block free
;  B-R block read
;  B-W block write
;  B-E block execute
;  B-P block pointer
;  B-r ??
;  B-w ??
;U user
;  U1 read
;  U2 write
;  U3-8 user stuff
;  U9 identify
;  U: reset
;  U0 no operation, restore Ux jump table
;  U0>C ??
;  U0>T Teszt
;  U0>B Fast serial
;  U0>V0 Verify off
;  U0>V1 Verify on
;  U0>R Retry count
;  U0>S Interleave
;  U0>M0 1541 mode 
;  U0>M1 1571 mode 
;  U0>H0 Side 0
;  U0>H1 Side 1
;  U0>MR Burst memory read
;  U0>MW Burst memory write
;  U0>drivenumber
;P pointer
;& utility
;C 
;  C copy
;  CP change partition
;  Cp change partition
;  CD chdir
;R
;  R rename
;  RD rmdir
;  R-H rename header
;  R-P rename partition
;S 
;  S scratch
;  S-8 switch 8
;  S-9 switch 9
;  S-D switch default
;  S-C scsi command
;N new
;G get
;  GEOS ?
;  G-D ?
;  G-P get partition
;L lock
;W ?
;  W-0 ?
;  W-1 ?
;T time
;  T-RA read time ascii
;  T-RB read time bcd
;  T-RD read time decimal
;  T-WA write time ascii
;  T-WB write time bcd
;  T-WD write time decimal
;D duplicate

commands	.text "PCBM/SIR"
commandslo	.byte <(cmd_p-1)
		.byte <(cmd_c-1)
		.byte <(cmd_b-1)
		.byte <(cmd_m-1)
		.byte <(cmd_cd2-1)
		.byte <(cmd_s-1)
		.byte <(cmd_i-1)
                .byte <(cmd_r-1)
commandshi	.byte >(cmd_p-1)
		.byte >(cmd_c-1)
		.byte >(cmd_b-1)
		.byte >(cmd_m-1)
		.byte >(cmd_cd2-1)
		.byte >(cmd_s-1)
		.byte >(cmd_i-1)
                .byte >(cmd_r-1)
                